/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/packit.h" 
#include "../include/error.h"

libnet_t *
packit_build_icmp(libnet_t *packet_d)
{
    if(libnet_build_icmpv4_echo(
        ihdr_o.ih_type,                     
        ihdr_o.ih_code,                 
        0,                                  
        ihdr_o.ih_id,                              
        ihdr_o.ih_seq,                                  
        payload,                   
        payload_s,                     
        packet_d,            
        0) == -1)
    {
        fprintf(stderr, "Error: Unable to build ICMPv4 header: %s\n", libnet_geterror(packet_d));
        exit(EXIT_FAILURE);
    }

    return packet_d; 
}

