/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/packit.h" 
#include "../include/error.h"

libnet_t *
packit_build_udp(libnet_t *packet_d)
{
    if(!uhdr_o.uh_sport)
        uhdr_o.uh_sport =  libnet_get_prand(LIBNET_PRu16);

    if(libnet_build_udp(
        uhdr_o.uh_sport, 
        uhdr_o.uh_dport, 
        PACKIT_UDP_H + payload_s, 
        0, 
        payload, 
        payload_s, 
        packet_d, 
        0) == -1)
    {
        fprintf(stderr, "Error: Unable to build UDP header: %s\n", libnet_geterror(packet_d));
        exit(EXIT_FAILURE);
    }

    return packet_d; 
}
