/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/packit.h"
#include "../include/error.h"

int hdrlen;

void 
display_udp_data(u_char *packet, char *time_stamp, struct libnet_ethernet_hdr *ehdr, struct libnet_ipv4_hdr *iphdr)
{
    struct libnet_udp_hdr *udphdr;
    struct in_addr ip_src, ip_dst;

    bzero(&ip_src, sizeof(ip_src));
    bzero(&ip_dst, sizeof(ip_dst));

    udphdr = (struct libnet_udp_hdr *)(packet + PACKIT_IPV4_H + hdrlen);

    fprintf(stderr, "%s udp ", time_stamp);

    if(linklayer)
    {
        fprintf(stderr, "%x:%x:%x:%x:%x:%x > ",
            ehdr->ether_shost[0], ehdr->ether_shost[1], ehdr->ether_shost[2], ehdr->ether_shost[3], ehdr->ether_shost[4], ehdr->ether_shost[5]);

        fprintf(stderr, "%x:%x:%x:%x:%x:%x ",
            ehdr->ether_shost[0], ehdr->ether_shost[1], ehdr->ether_shost[2], ehdr->ether_shost[3], ehdr->ether_shost[4], ehdr->ether_shost[5]);
    }

    fprintf(stderr, "%s.%u > %s.%u: ulen %d ", 
        libnet_addr2name4(iphdr->ip_src.s_addr, resolve), 
        htons(udphdr->uh_sport), 
        libnet_addr2name4(iphdr->ip_dst.s_addr, resolve), 
        htons(udphdr->uh_dport), 
        iphdr->ip_ttl,
        udphdr->uh_ulen);

    if(verbose)
        fprintf(stderr, "(ttl %d, id %d)", iphdr->ip_ttl, iphdr->ip_id);

    fprintf(stderr, "\n");

    return;
}
