/*
 * author: Darren Bounds <darren@sfhn.net>
 * copyright: Copyright (c) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 * 
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../include/packit.h"
#include "../include/error.h"

int opt;
char *optarg;

int
main(int argc, char *argv[])
{
    if(argc < 2)
        usage();
    else if(getuid() != 0)
    {
        fprintf(stderr, "Error: You're not root\n");
        exit(EXIT_FAILURE);
    }
    else
    {
        while((opt = getopt(argc, argv, "1246")) != -1)
        {
            switch(opt)
            {
                case '1':
                    packit_parse_capture_options(argc, argv);
                    break;

                case '4':
                    packit_parse_inject_options(argc, argv, 4);
                    break;

                default:
                    usage();
                    break;
            }
        }
    }

    exit(EXIT_SUCCESS);
}        
