/*
 * author: Darren Bounds <darren@sfhn.net
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * packit official page at http://www.intrusense.com/~dbounds
 */

#include <stdio.h>

#include "../include/version.h"

void
usage()
{
    fprintf(stderr, "usage: packit [-1]|[-4] [-options] 'expression'\n\n");
    fprintf(stderr, "Modes (You must select one of these):\n");
    fprintf(stderr, "  -1          Packet capture\n");
    fprintf(stderr, "  -4          IPv4 packet injection\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "Packet capture:\n");
    fprintf(stderr, "  -i device   Select listening device\n");
    fprintf(stderr, "  -r file     Read data from file\n");
    fprintf(stderr, "  -v          Slightly more data (ie: ttl, id, length)\n");
    fprintf(stderr, "  -w file     Write data to file\n");
    fprintf(stderr, "  -e          Display link-level data\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "IPv4 packet injection:\n");
    fprintf(stderr, "  -T          Send TCP packet\n");
    fprintf(stderr, "  -U          Send UDP packet\n");
    fprintf(stderr, "  -I          Send ICMP packet\n");
    fprintf(stderr, "IP\n");
    fprintf(stderr, "  -d address  Destination address\n");
    fprintf(stderr, "  -n id       Id (default: random)\n");
    fprintf(stderr, "  -O tos      Type of service (default: 16 (LOWDELAY))\n");
    fprintf(stderr, "  -r          Random source address\n");
    fprintf(stderr, "  -s address  Source address\n");
    fprintf(stderr, "  -t ttl      Time to live (default: 128)\n");
    fprintf(stderr, "TCP/UDP\n");
    fprintf(stderr, "  -a ack      Acknowledgement number\n");
    fprintf(stderr, "  -D port     Destination port\n");
    fprintf(stderr, "  -F flags    Flags (format: -F UAPRSF)\n");
    fprintf(stderr, "  -p payload  Payload\n");
    fprintf(stderr, "  -q seq      Sequence number\n");
    fprintf(stderr, "  -S port     Source port (default: random)\n");
    fprintf(stderr, "  -u urg      Urgent pointer\n");	
    fprintf(stderr, "  -W size     Window size (default: 1500)\n");
    fprintf(stderr, "ICMP\n");
    fprintf(stderr, "  -C code     Code (default: 0)\n");
    fprintf(stderr, "  -K type     Type (default: 8)\n");
    fprintf(stderr, "  -N id       Id (default: random)\n");
    fprintf(stderr, "  -p payload  Payload\n");
    fprintf(stderr, "  -Q seq      Sequence number (default: random)\n");
    fprintf(stderr, "Ethernet\n");
    fprintf(stderr, "  -e enet     Source ethernet address\n");
    fprintf(stderr, "  -E enet     Destination ethernet address\n");
    fprintf(stderr, "General\n");
    fprintf(stderr, "  -c count    Number of packets to send\n");
    fprintf(stderr, "  -i device   Select network device\n");
    fprintf(stderr, "  -w seconds  Interval between sending each packet\n");
    fprintf(stderr, "\n");
    fprintf(stderr, "packit %s by %s\n", PACKIT_VERSION, PACKIT_AUTHOR);

    exit(0);
}

